//{$WARNINGS OFF}
//{$WARN SYMBOL_PLATFORM OFF}
//{$WARN UNIT_PLATFORM OFF}
//=============================================================================
//  GDI+ ֌WTv
//  SetResolution \bhɂ摜̉𑜓x̐ݒ
//
//-----------------------------------------------------------------------------
//
//  ygpz
//
//  TCg̃AvP[VށCR|[lgCR[hނ́C]ځCρCzz
//  (IWiCϔ)Ȃǂ͑SĎRłDppRłDACgp̋L
//  ڋ`܂DIWî̂pƂ邱Ƃ͋֎~܂D
//  ȂC{TCg̃vOR[hgpƂɂĐCȂ
//  QCɊւĂ҂͈؊֗^Ȃ̂Ƃ܂DD
//
//-----------------------------------------------------------------------------
//
//  yz
//
//  2013N0718 `
//
//-----------------------------------------------------------------------------
//
//  ymFz
//
//  Windows 7 U64(SP1) + Delphi XE(UP1) Pro
//
//  Presented by Mr.XRAY
//  http://mrxray.on.coocan.jp/
//=============================================================================
unit Unit1;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, ExtCtrls, ComCtrls, StdCtrls, GDIPAPI, GDIPOBJ, GDIPUTIL;

type
  TForm1 = class(TForm)
    Button1: TButton;
    Button2: TButton;
    LabeledEdit1: TLabeledEdit;
    LabeledEdit2: TLabeledEdit;
    OpenDialog1: TOpenDialog;
    procedure FormCreate(Sender: TObject);
    procedure Button1Click(Sender: TObject);
    procedure Button2Click(Sender: TObject);
    procedure FormPaint(Sender: TObject);
  private
    { Private 錾 }
    FImageFilePath : string;
    FInitialDir    : string;
  public
    { Public 錾 }
  end;

var
  Form1: TForm1;

implementation

{$R *.dfm}

//=============================================================================
//  tH[̏
//=============================================================================
procedure TForm1.FormCreate(Sender: TObject);
begin
  Self.Caption := 'GDI+  摜̉𑜓x̎擾Ɛݒ';

  FImageFilePath := '';
  FInitialDir    := '';
end;

//=============================================================================
//  [摜t@C]{^
//=============================================================================
procedure TForm1.Button1Click(Sender: TObject);
var
  LGPImage     : TGPImage;
  LXResolution : Single;
  LYResolution : Single;
begin
  if FInitialDir = '' then FInitialDir := ExpandFileName('../');

  OpenDialog1.Filter     := '摜t@C|*.png;*.jpg;*.jpeg;*.bmp;*.gif';
  OpenDialog1.InitialDir := FInitialDir;

  if OpenDialog1.Execute then begin
    LabeledEdit1.Text := '';
    LabeledEdit2.Text := '';

    FInitialDir    := ExtractFileDir(OpenDialog1.FileName);
    FImageFilePath := OpenDialog1.FileName;

    //摜t@CTGPImagẽCX^X𐶐
    LGPImage := TGPBitmap.Create(FImageFilePath);

    //𑜓x擾
    LXResolution := LGPImage.GetHorizontalResolution;
    LYResolution := LGPImage.GetVerticalResolution;

    //擾𑜓x\
    LabeledEdit1.Text := IntToStr(Trunc(LXResolution));
    LabeledEdit2.Text := IntToStr(Trunc(LYResolution));

    LGPImage.Free;
    //摜\
    //𑜓x̎擾ƕύXł΁C摜\Kv͂Ȃ
    Invalidate;
  end;
end;

//=============================================================================
//  [ۑ]{^
//  𑜓xύXĕۑ
//=============================================================================
procedure TForm1.Button2Click(Sender: TObject);
var
  LImageWidth  : Cardinal;
  LImageHeight : Cardinal;
  LGPGraphic   : TGPGraphics;
  LGPBitmap    : TGPBitmap;
  LGPNewBitmap : TGPBitmap;
  LPixelFormat : Integer;
  LImgGUID     : TGUID;
begin
  if FImageFilePath = '' then exit;

  //炩nilĂƃCX^X̗Ľoe
  //[qg]\Ă܂
  {$HINTS OFF}
  LGPGraphic   := nil;
  LGPBitmap    := nil;
  LGPNewBitmap := nil;
  {$HINTS ON}

  //摜t@CǂݍTGPBitmapk̃CX^X𐶐
  //摜̕ƍ擾Ă
  LGPBitmap    := TGPBitmap.Create(FImageFilePath);
  LImageWidth  := LGPBitmap.GetWidth;
  LImageHeight := LGPBitmap.GetHeight;

  //ʂTGPBitmap̃CX^X𐶐
  //sNZtH[}bg̎w(ꂪȂƕۑɎs悤)
  LPixelFormat  := LGPBitmap.GetPixelFormat;
  LGPNewBitmap := TGPBitmap.Create(LImageWidth, LImageHeight, LPixelFormat);
  //𑜓xύX
  LGPNewBitmap.SetResolution(300.0, 300.0);

  //VTGPBitmap`ƂTGPGraphics𐶐
  //TGPBitmap̓e`悷
  if Assigned(LGPGraphic) then LGPGraphic.Free;
  LGPGraphic := TGPGraphics.Create(LGPNewBitmap);
  LGPGraphic.DrawImage(LGPBitmap, 0, 0, LImageWidth, LImageHeight);

  //Ώۂ̉摜̃CX^XL̂܂܂Ə㏑ۑłȂ
  FreeAndNil(LGPBitmap);
  FreeAndNil(LGPGraphic);

  //JPEG摜Ƃĕۑ
  if GetEncoderClsid('image/jpeg', LImgGUID) >= 0 then begin
    if LGPNewBitmap.Save('XXX.jpg', LImgGUID) <> Ok then begin
      MessageBox(Handle, 'ۑł܂ł', '', MB_ICONINFORMATION);
    end;
  end;

  if Assigned(LGPNewBitmap) then FreeAndNil(LGPNewBitmap);
  if Assigned(LGPBitmap)    then FreeAndNil(LGPBitmap);
  if Assigned(LGPGraphic)   then FreeAndNil(LGPGraphic);
end;

//=============================================================================
//  Form1OnPaintCxg
//  摜`悵ȂĂ̂ł΁C̃Cxg̃R[h͕sv
//=============================================================================
procedure TForm1.FormPaint(Sender: TObject);
var
  LImageWidth  : Cardinal;
  LImageHeight : Cardinal;
  LGPGraphic   : TGPGraphics;
  LGPBitmap    : TGPBitmap;
begin
  if FImageFilePath = '' then exit;

  //炩nilĂƃCX^X̗Ľoe
  //[qg]\Ă܂
  {$HINTS OFF}
  LGPGraphic := nil;
  LGPBitmap  := nil;
  {$HINTS ON}

  //摜t@CǂݍTGPBitmapk̃CX^X𐶐
  //摜̕ƍ擾Ă
  LGPBitmap    := TGPBitmap.Create(FImageFilePath);
  LImageWidth  := LGPBitmap.GetWidth;
  LImageHeight := LGPBitmap.GetHeight;

  //mF̂߂ɂForm1Canvasɕ`
  LGPGraphic := TGPGraphics.Create(Canvas.Handle);
  LGPGraphic.DrawImage(LGPBitmap, 8, 85, LImageWidth, LImageHeight);

  if Assigned(LGPBitmap)  then FreeAndNil(LGPBitmap);
  if Assigned(LGPGraphic) then FreeAndNil(LGPGraphic);
end;

end.
