//{$WARNINGS OFF}
//{$WARN SYMBOL_PLATFORM OFF}
//{$WARN UNIT_PLATFORM OFF}
//=============================================================================
//  GDI+ ֌WTv
//  摜̉𑜓x̎擾ƕύX
//  Delphi GDI+ Library for use with Delphi 2009 (version 1.2) gpTv
//
//-----------------------------------------------------------------------------
//
//  ygpz
//
//  TCg̃AvP[VށCR|[lgCR[hނ́C]ځCρCzz
//  (IWiCϔ)Ȃǂ͑SĎRłDppRłDACgp̋L
//  ڋ`܂DIWî̂pƂ邱Ƃ͋֎~܂D
//  ȂC{TCg̃vOR[hgpƂɂĐCȂ
//  QCɊւĂ҂͈؊֗^Ȃ̂Ƃ܂DD
//
//-----------------------------------------------------------------------------
//
//  yz
//
//  2013N0718 `
//
//-----------------------------------------------------------------------------
//
//  ymFz
//
//  Windows 7 U64(SP1) + Delphi XE(UP1) Pro
//
//  Presented by Mr.XRAY
//  http://mrxray.on.coocan.jp/
//=============================================================================
unit Unit1;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, ExtCtrls, ComCtrls, StdCtrls, GDIPlus;

type
  TForm1 = class(TForm)
    Button1: TButton;
    Button2: TButton;
    LabeledEdit1: TLabeledEdit;
    LabeledEdit2: TLabeledEdit;
    OpenDialog1: TOpenDialog;
    procedure FormCreate(Sender: TObject);
    procedure Button1Click(Sender: TObject);
    procedure Button2Click(Sender: TObject);
    procedure FormPaint(Sender: TObject);
  private
    { Private 錾 }
    FImageFilePath : string;
    FInitialDir    : string;
  public
    { Public 錾 }
  end;

var
  Form1: TForm1;

implementation

{$R *.dfm}

//=============================================================================
//  tH[̏
//=============================================================================
procedure TForm1.FormCreate(Sender: TObject);
begin
  Self.Caption := 'GDI+  摜̉𑜓x̎擾Ɛݒ';

  FImageFilePath := '';
  FInitialDir    := '';
end;

//=============================================================================
//  [摜t@C]{^
//=============================================================================
procedure TForm1.Button1Click(Sender: TObject);
var
  LGDImage     : IGPImage;
  LXResolution : Single;
  LYResolution : Single;
begin
  if FInitialDir = '' then FInitialDir := ExpandFileName('../');

  OpenDialog1.Filter     := '摜t@C|*.png;*.jpg;*.jpeg;*.bmp;*.gif';
  OpenDialog1.InitialDir := FInitialDir;

  if OpenDialog1.Execute then begin
    FInitialDir    := ExtractFileDir(OpenDialog1.FileName);
    FImageFilePath := OpenDialog1.FileName;

    //摜t@CTGPImagẽCX^X𐶐
    LGDImage := TGPBitmap.Create(FImageFilePath);

    //𑜓x擾
    LXResolution := LGDImage.GetHorizontalResolution;
    LYResolution := LGDImage.GetVerticalResolution;

    //擾𑜓x\
    LabeledEdit1.Text := IntToStr(Trunc(LXResolution));
    LabeledEdit2.Text := IntToStr(Trunc(LYResolution));

    //摜`
    //𑜓x̎擾ƕύXł΁C摜\Kv͂Ȃ
    Invalidate;
  end;
end;

//=============================================================================
//  [ۑ]{^
//  𑜓xύXĕۑ
//=============================================================================
procedure TForm1.Button2Click(Sender: TObject);
var
  LImageWidth  : Cardinal;
  LImageHeight : Cardinal;
  LGPGraphic   : IGPGraphics;
  LGPBitmap    : IGPBitmap;
  LPixelFormat : Integer;
  LGPNewBitmap : IGPBitmap;
begin
  if FImageFilePath = '' then exit;

  //摜t@CǂݍIGPBitmapk̃CX^X𐶐
  //摜̕ƍ擾Ă
  LGPBitmap    := TGPBitmap.Create(FImageFilePath);
  LImageWidth  := LGPBitmap.Width;
  LImageHeight := LGPBitmap.Height;

  //ʂIGPBitmap̃CX^X𐶐
  //sNZtH[}bg̎w(ꂪȂƕۑɎs悤)
  LPixelFormat := LGPBitmap.PixelFormat;
  LGPNewBitmap := TGPBitmap.Create(LImageWidth, LImageHeight, LPixelFormat);
  //𑜓xύX
  LGPNewBitmap.SetResolution(300.0, 300.0);

  //VTGPBitmap`ɂTGPGraphics𐶐
  //ɌTGPBitmap̓e`悷
  LGPGraphic := TGPGraphics.FromImage(LGPNewBitmap);
  LGPGraphic.DrawImage(LGPBitmap, 0, 0, LImageWidth, LImageHeight);

  //Ώۂ̉摜̃CX^XL̂܂܂Ə㏑ۑłȂ
  LGPBitmap  := nil;
  LGPGraphic := nil;

  //JPEG摜Ƃĕۑ
  LGPNewBitmap.Save('XXX.jpg', TGPImageFormat.Jpeg);
end;

//=============================================================================
//  Form1OnPaintCxg
//  摜`悵ȂĂ̂ł΁C̃Cxg̃R[h͕sv
//=============================================================================
procedure TForm1.FormPaint(Sender: TObject);
var
  LImageWidth  : Cardinal;
  LImageHeight : Cardinal;
  LGPGraphic   : IGPGraphics;
  LGPBitmap    : IGPBitmap;
begin
  if FImageFilePath = '' then exit;

  //摜t@CǂݍIGPBitmapk̃CX^X𐶐
  //摜̕ƍ擾Ă
  LGPBitmap   := TGPBitmap.Create(FImageFilePath);
  LImageWidth  := LGPBitmap.Width;
  LImageHeight := LGPBitmap.Height;

  //mF̂߂ɂForm1Canvasɕ`
  LGPGraphic := TGPGraphics.Create(Canvas.Handle);
  LGPGraphic.DrawImage(LGPBitmap, 8, 85, LImageWidth, LImageHeight);

  //.NET݊GDI+Cu͉sv
end;

end.
