//{$WARNINGS OFF}
//{$WARN SYMBOL_PLATFORM OFF}
//{$WARN UNIT_PLATFORM OFF}
//=============================================================================
//  GDI+ ֌WTv
//  SetResolution \bhɂ摜̉𑜓x̐ݒ - TImage ɕ`
//
//-----------------------------------------------------------------------------
//
//  ygpz
//
//  TCg̃AvP[VށCR|[lgCR[hނ́C]ځCρCzz
//  (IWiCϔ)Ȃǂ͑SĎRłDppRłDACgp̋L
//  ڋ`܂DIWî̂pƂ邱Ƃ͋֎~܂D
//  ȂC{TCg̃vOR[hgpƂɂĐCȂ
//  QCɊւĂ҂͈؊֗^Ȃ̂Ƃ܂DD
//
//-----------------------------------------------------------------------------
//
//  yz
//
//  2013N0718 `
//
//-----------------------------------------------------------------------------
//
//  ymFz
//
//  Windows 7 U64(SP1) + Delphi XE(UP1) Pro
//
//  Presented by Mr.XRAY
//  http://mrxray.on.coocan.jp/
//=============================================================================
unit Unit1;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, ExtCtrls, ComCtrls, StdCtrls, GDIPAPI, GDIPOBJ, GDIPUTIL;

type
  TForm1 = class(TForm)
    Button1: TButton;
    Button2: TButton;
    LabeledEdit1: TLabeledEdit;
    LabeledEdit2: TLabeledEdit;
    OpenDialog1: TOpenDialog;
    Image1: TImage;
    procedure FormCreate(Sender: TObject);
    procedure Button1Click(Sender: TObject);
    procedure Button2Click(Sender: TObject);
    procedure FormDestroy(Sender: TObject);
  private
    { Private 錾 }
    FImageFilePath : string;
    FInitialDir    : string;
    FImageWidth    : Cardinal;
    FImageHeight   : Cardinal;
    FGPGraphic     : TGPGraphics;
    FGPBitmap      : TGPBitmap;
  public
    { Public 錾 }
  end;

var
  Form1: TForm1;

implementation

{$R *.dfm}

//=============================================================================
//  tH[̏
//=============================================================================
procedure TForm1.FormCreate(Sender: TObject);
begin
  Self.Caption := 'GDI+  摜̉𑜓x̎擾Ɛݒ';

  FInitialDir    := '';

  Image1.Left := 8;
  Image1.Top  := 85;

  //炩nilĂƃCX^X̗Ľoe
  //[qg]\Ă܂
  FGPGraphic   := nil;
  FGPBitmap    := nil;
end;

//=============================================================================
//  Ȉ
//=============================================================================
procedure TForm1.FormDestroy(Sender: TObject);
begin
  if Assigned(FGPGraphic) then FreeAndNil(FGPGraphic);
  if Assigned(FGPBitmap)  then FreeAndNil(FGPBitmap);
end;

//=============================================================================
//  [摜t@C]{^
//=============================================================================
procedure TForm1.Button1Click(Sender: TObject);
var
  LXResolution : Single;
  LYResolution : Single;
begin
  if FInitialDir = '' then FInitialDir := ExpandFileName('../');

  OpenDialog1.Filter     := '摜t@C|*.png;*.jpg;*.jpeg;*.bmp;*.gif';
  OpenDialog1.InitialDir := FInitialDir;

  if OpenDialog1.Execute then begin
    LabeledEdit1.Text := '';
    LabeledEdit2.Text := '';
    //Image1̉摜NA
    //NAȂƕʂ̉摜\łȂ
    Image1.Picture.Assign(nil);

    FInitialDir    := ExtractFileDir(OpenDialog1.FileName);
    FImageFilePath := OpenDialog1.FileName;

    //摜t@CTGPImagẽCX^X𐶐
    if Assigned(FGPBitmap) then FreeAndNil(FGPBitmap);
    FGPBitmap := TGPBitmap.Create(FImageFilePath);

    //𑜓x擾
    LXResolution := FGPBitmap.GetHorizontalResolution;
    LYResolution := FGPBitmap.GetVerticalResolution;

    //擾𑜓x\
    LabeledEdit1.Text := IntToStr(Trunc(LXResolution));
    LabeledEdit2.Text := IntToStr(Trunc(LYResolution));

    //摜̕ƍ擾CImage1̃TCY̑傫ɂ
    FImageWidth   := FGPBitmap.GetWidth;
    FImageHeight  := FGPBitmap.GetHeight;
    Image1.Width  := FImageWidth;
    Image1.Height := FImageHeight;

    //mF̂߂ɂImage1Canvasɕ`
    //𑜓x̎擾ƕύXł΁C摜\Kv͂Ȃ
    if Assigned(FGPGraphic) then FreeAndNil(FGPGraphic);
    FGPGraphic := TGPGraphics.Create(Image1.Canvas.Handle);
    FGPGraphic.DrawImage(FGPBitmap, 0, 0, FImageWidth, FImageHeight);
  end;
end;

//=============================================================================
//  [ۑ]{^
//  𑜓xύXĕۑ
//=============================================================================
procedure TForm1.Button2Click(Sender: TObject);
var
  LGPNewBitmap : TGPBitmap;
  LPixelFormat : Integer;
  LImgGUID     : TGUID;
begin
  if FImageFilePath = '' then exit;

  //ʂTGPBitmap̃CX^X𐶐
  //sNZtH[}bg̎w(ꂪȂƕۑɎs悤)
  LPixelFormat  := FGPBitmap.GetPixelFormat;
  LGPNewBitmap := TGPBitmap.Create(FImageWidth, FImageHeight, LPixelFormat);
  //𑜓xύX
  LGPNewBitmap.SetResolution(300.0, 300.0);

  //VTGPBitmap`ƂTGPGraphics𐶐
  //TGPBitmap̓e`悷
  if Assigned(FGPGraphic) then FGPGraphic.Free;
  FGPGraphic := TGPGraphics.Create(LGPNewBitmap);
  FGPGraphic.DrawImage(FGPBitmap, 0, 0, FImageWidth, FImageHeight);

  //Ώۂ̉摜̃CX^XL̂܂܂Ə㏑ۑłȂ
  FreeAndNil(FGPBitmap);
  FreeAndNil(FGPGraphic);

  //JPEG摜Ƃĕۑ
  if GetEncoderClsid('image/jpeg', LImgGUID) >= 0 then begin
    if LGPNewBitmap.Save('XXX.jpg', LImgGUID) <> Ok then begin
      MessageBox(Handle, 'ۑł܂ł', '', MB_ICONINFORMATION);
    end;
  end;

  FreeAndNil(LGPNewBitmap);
end;

end.
