//{$WARNINGS OFF}
//{$WARN SYMBOL_PLATFORM OFF}
//{$WARN UNIT_PLATFORM OFF}
//=============================================================================
//  GDI+ ֌WTv
//  摜̉𑜓x̎擾ƕύX
//  摜̃vpeB^Ogp@
//
//-----------------------------------------------------------------------------
//
//  ygpz
//
//  TCg̃AvP[VށCR|[lgCR[hނ́C]ځCρCzz
//  (IWiCϔ)Ȃǂ͑SĎRłDppRłDACgp̋L
//  ڋ`܂DIWî̂pƂ邱Ƃ͋֎~܂D
//  ȂC{TCg̃vOR[hgpƂɂĐCȂ
//  QCɊւĂ҂͈؊֗^Ȃ̂Ƃ܂DD
//
//-----------------------------------------------------------------------------
//
//  yz
//
//  013N0718 `
//
//  2013N0721
//    E`̃vpeB̔zCIzgpɕύX
//
//-----------------------------------------------------------------------------
//
//  ymFz
//
//  Windows 7 U64(SP1) + Delphi XE(UP1) Pro
//
//  Presented by Mr.XRAY
//  http://mrxray.on.coocan.jp/
//=============================================================================
unit Unit1;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, ExtCtrls, ComCtrls, StdCtrls, GDIPAPI, GDIPOBJ, GDIPUTIL;

type
  TForm1 = class(TForm)
    Button1: TButton;
    Button2: TButton;
    LabeledEdit1: TLabeledEdit;
    LabeledEdit2: TLabeledEdit;
    OpenDialog1: TOpenDialog;
    Image1: TImage;
    procedure FormCreate(Sender: TObject);
    procedure Button1Click(Sender: TObject);
    procedure Button2Click(Sender: TObject);
    procedure FormDestroy(Sender: TObject);
  private
    { Private 錾 }
    FImageFilePath : string;
    FInitialDir    : string;
    FMemStream     : TMemoryStream;
  public
    { Public 錾 }
  end;

var
  Form1: TForm1;

implementation

{$R *.dfm}

//=============================================================================
//  tH[̏
//=============================================================================
procedure TForm1.FormCreate(Sender: TObject);
begin
  Self.Caption := 'GDI+  摜̉𑜓x̎擾Ɛݒ';

  FInitialDir    := '';

  Image1.Left := 8;
  Image1.Top  := 85;

  FMemStream := TMemoryStream.Create;
end;

//=============================================================================
//  Ȉ
//=============================================================================
procedure TForm1.FormDestroy(Sender: TObject);
begin
  FreeAndNil(FMemStream);
end;

//=============================================================================
//  [摜t@C]{^
//=============================================================================
procedure TForm1.Button1Click(Sender: TObject);
var
  LGPGraphic     : TGPGraphics;
  LGPBitmap      : TGPBitmap;
  LImageWidth    : Cardinal;
  LImageHeight   : Cardinal;
  LpPropItem     : PPropertyItem;
  LIdValue       : Cardinal;
  LBufferSize    : Cardinal;
  LRationalValue : array of Cardinal;
  LImgGUID       : TGUID;
begin
  if FInitialDir = '' then FInitialDir := ExpandFileName('../');

  OpenDialog1.Filter     := '摜t@C|*.jpg';
  OpenDialog1.InitialDir := FInitialDir;

  if OpenDialog1.Execute then begin
    LabeledEdit1.Text := '';
    LabeledEdit2.Text := '';
    Image1.Picture.Assign(nil);

    FInitialDir    := ExtractFileDir(OpenDialog1.FileName);
    FImageFilePath := OpenDialog1.FileName;

    //摜t@CTGPImagẽCX^X𐶐
    LGPBitmap := TGPBitmap.Create(FImageFilePath);

    //摜̕ƍ擾CImage1̃TCY̑傫ɂ
    LImageWidth   := LGPBitmap.GetWidth;
    LImageHeight  := LGPBitmap.GetHeight;
    Image1.Width  := LImageWidth;
    Image1.Height := LImageHeight;

    //mF̂߂ɂImage1Canvasɕ`
    LGPGraphic := TGPGraphics.Create(Image1.Canvas.Handle);
    LGPGraphic.DrawImage(LGPBitmap, 0, 0, LImageWidth, LImageHeight);


    //̉𑜓x̎擾D𑜓xRational(LE)`Ŋi[Ă
    LIdValue    := PropertyTagXResolution;
    LBufferSize := LGPBitmap.GetPropertyItemSize(LIdValue);
    if LBufferSize > 0 then begin
      GetMem(LpPropItem, LBufferSize);

      //ƕqŔzvf2Kv
      SetLength(LRationalValue, 2);
      try
        LGPBitmap.GetPropertyItem(LIdValue, LBufferSize, LpPropItem);
        LRationalValue    := LpPropItem^.value;
        LabeledEdit1.Text := IntToStr(LRationalValue[0]);
      finally
        FreeMem(LpPropItem);
      end;
    end;

    //c̉𑜓x̎擾D𑜓xRational(LE)`Ŋi[Ă
    LIdValue    := PropertyTagYResolution;
    LBufferSize := LGPBitmap.GetPropertyItemSize(LIdValue);
    if LBufferSize > 0 then begin
      GetMem(LpPropItem, LBufferSize);

      //ƕqŔzvf2Kv
      SetLength(LRationalValue, 2);
      try
        LGPBitmap.GetPropertyItem(LIdValue, LBufferSize, LpPropItem);
        LRationalValue    := LpPropItem^.value;
        LabeledEdit2.Text := IntToStr(LRationalValue[0]);
      finally
        FreeMem(LpPropItem);
      end;
    end;

    //摜Xg[ɕۑ
    FMemStream.Clear;
    if GetEncoderClsid('image/jpeg', LImgGUID) >= 0 then begin
      LGPBitmap.Save(TStreamAdapter.Create(FMemStream), LImgGUID);
    end;

    LGPGraphic.Free;
    LGPBitmap.Free;
  end;
end;

//=============================================================================
//  [ۑ]{^
//  𑜓xύXĕۑ
//=============================================================================
procedure TForm1.Button2Click(Sender: TObject);
var
  LGPBitmap      : TGPBitmap;
  LPropItem      : TPropertyItem;
  LRationalValue : array of Cardinal;
  LImgGUID       : TGUID;
begin
  if FMemStream.Size <= 0 then exit;

  //Xg[TGPBitmap̃CX^X𐶐
  LGPBitmap := TGPBitmap.Create(TStreamAdapter.Create(FMemStream));

  
  //̉𑜓xݒ
  //ƕqŔzvf2Kv
  SetLength(LRationalValue, 2);
  LPropItem.id     := PropertyTagXResolution;
  LPropItem.type_  := PropertyTagTypeRational;
  //Iz̃oCg
  LPropItem.length := Length(LRationalValue) * SizeOf(LRationalValue);

  
  LRationalValue[0] := 300;
  LRationalValue[1] := 1;
  LPropItem.value   := @LRationalValue[0];
  LGPBitmap.SetPropertyItem(LPropItem);
  
  //c̉𑜓xݒ
  //ƕqŔzvf2Kv
  SetLength(LRationalValue, 2);
  LPropItem.id     := PropertyTagYResolution;
  LPropItem.type_  := PropertyTagTypeRational;
  //Iz̃oCg
  LPropItem.length := Length(LRationalValue) * SizeOf(LRationalValue);

  LRationalValue[0] := 300;
  LRationalValue[1] := 1;
  LPropItem.value   := @LRationalValue[0];
  LGPBitmap.SetPropertyItem(LPropItem);

  //JPEG摜Ƃĕۑ
  //ł͕ʂ̖OŕۑĂ邪COɂΏ㏑ۑƂȂ
  if GetEncoderClsid('image/jpeg', LImgGUID) >= 0 then begin
    LGPBitmap.Save('XXX.jpg', LImgGUID);
  end;

  LGPBitmap.Free;
end;

end.
